/*
  Denna fil är ett exempel på hur man kan implementera klasserna som
  visas i UML-diagrammet i "animal_house_UML.pdf"
 */

#pragma once
#include <string>
#include <vector>

class Animal // Basklass för djur
{
public:
    Animal(std::string in_name, int in_age):
	name{in_name}, age{in_age}{}; 
    virtual ~Animal() = default;
    
    void introduce_yourself();
    virtual void take_for_walk();    
protected:
    std::string name;
    int age;
};

class Cat: public Animal // Arv: en katt ÄR ett djur
{
public:
    Cat(std::string in_name, int in_age):
	Animal(in_name, in_age){};
    
    void introduce_yourself();
    void take_for_walk() override;     
};

class Dog: public Animal // Arv: en hund ÄR ett djur
{
public:
    Dog(std::string in_name, int in_age):
	Animal(in_name, in_age){};
    
    void introduce_yourself();
    void take_for_walk() override;    
};


class House
{
public:
    House() = default;
    void add_animal(Animal*);
    void print(); 
private:
    std::vector<Animal*> animal_list; // Association: ett hus HAR 0
				      // eller flera djur.
};
